unit stringfuncs;

{

    HTML
Copyright (c) 2013  . .

}

interface

function htmlspecialchars_decode(s: string): string;

function htmlspecialchars(s: string): string;

//   
function trim(const Line: string): string;

//        
function str_replace(s, ToFind, ToReplace: string; var Counter: integer): string;

//     ,   
function FIOToString(SurName, Name, FatherName: string): string;


implementation

uses SysUtils;

//   
function trim(const Line: string): string;
var
  b: boolean;
begin
  Result := Line;
  if (Result <> '') then
  begin
    //  
    repeat
      b := False;
      if Result <> '' then
        if (Result[1] = #13) or (Result[1] = #10) or (Result[1] = #32) or (Result[1] = #9) then
          b := True;
      if b then
        Result := copy(Result, 2, Length(Result) - 1);
    until b = False;
    //  
    repeat
      b := False;
      if Result <> '' then
        if (Result[Length(Result)] = #13) or (Result[Length(Result)] = #10) or (Result[Length(Result)] = #32) or
          (Result[Length(Result)] = #9) then
          b := True;
      if b then
        Result := copy(Result, 1, Length(Result) - 1);
    until b = False;
  end;
end;

function strlpos(const SubStr, Str: string; StartPos: integer): integer;
var
  Haystack: string;
begin
  if StartPos > Length(Str) then
    Result := 0
  else if Length(Str) < Length(SubStr) then
    Result := 0
  else if Length(SubStr) = 0 then
    Result := 0
  else
  begin
    if StartPos = 1 then
      Haystack := Str
    else
      HayStack := Copy(Str, StartPos, Length(Str) - StartPos + 1);
    Result := Pos(SubStr, Haystack);
    if Result > 0 then
    begin
      Inc(Result, StartPos);
      Dec(Result);
    end;
  end;
end;

//        
function str_replace(s, ToFind, ToReplace: string; var Counter: integer): string;
var
  a: string;
  i, j: integer;
begin
  Counter := 0;
  if Pos(ToFind, s) = 0 then
    Result := s
  else
  begin
    a := s;
    i := 1;
    repeat
      j := strlpos(ToFind, a, i);
      if j > 0 then
      begin
        Inc(Counter);
        i := j + Length(ToReplace);
        a := Copy(a, 1, j - 1) + ToReplace +
          Copy(a, j + Length(ToFind), Length(a) - j - Length(ToFind) + 1);
      end;
    until j = 0;
    Result := a;
  end;
end;

function htmlspecialchars_decode(s: string): string;
const
  ReplaceArr: array[1..8, 1..2] of string =
    (
    ('quot', '"'),
    ('laquo', ''),
    ('raquo', ''),
    ('gt', '>'),
    ('lt', '<'),
    ('amp', '&'),
    ('#039', #39),
    ('nbsp', ' ')
    );

var
  Counter, i: integer;
begin
  Result := s;
  for i := 1 to 8 do
    Result := str_replace(Result, '&' + ReplaceArr[i, 1] + ';', ReplaceArr[i, 2], Counter);
end;

function htmlspecialchars(s: string): string;
const
  ReplaceArr: array[1..7, 1..2] of string =
    (
    ('quot', '"'),
    ('laquo', ''),
    ('raquo', ''),
    ('gt', '>'),
    ('lt', '<'),
    ('amp', '&'),
    ('#039', #39)
    );

var
  Counter, i: integer;
begin
  Result := s;
  for i := 1 to 7 do
    Result := str_replace(Result, ReplaceArr[i, 2], '&' + ReplaceArr[i, 1] + ';', Counter);
end;

function FIOToString(SurName, Name, FatherName: string): string;
begin
  Result := SurName;
  if Result <> '' then
    Result := Result + ' ';
  Result := Result + Name;
  if Result <> '' then
    Result := Result + ' ';
  Result := Result + FatherName;
end;

end.
